{------------------------------------------------------
 ணࠬ  襭 ⥬  ࠢ ()
 ⨯ Ax = B,  몥 ணࠬ஢ 窠,
  FreePascal (http://www.freepascal.org/).
 ⮤ .
 
 :
    -  ⨬樨:
    fpc ./gauss.pas			
    
    -  ⨬樥  ᪮ 믮:
    fpc -O3 ./gauss.pas		
------------------------------------------------------}

{$mode objfpc}
Program test_gauss;

Uses SysUtils;

Type
  TMatrix = array of array of Double;
  Tvector = array of Double;

{------------------------------------------------------
 㭪 ᫥ ⥬  ࠢ 
 ⨯ Ax=B ⮤ .
 室 ࠬ:
	a -  樥⮢ n * n; 
	b -  ᢮ 童.
	n - ⢮ ࠢ;
 頥 祭:
	 ६ b 頥  襭 
	ࠧ஬ n.
 ----------------------------------------------------- }

procedure gauss(a: TMatrix; var b: TVector; n: integer);
Var
  i, k, j: integer;

Begin
  // אַ 室
  for i:=0 to n-1 Do
  Begin  
    for j:=i+1 to n-1 Do
      a[i,j] := a[i,j]/a[i,i];
    
    b[i] := b[i]/a[i,i];
    if i=n then 
      Break;
    
    for k:=i+1 to n-1 Do
    Begin  
      if a[k,i]=0 then 
        Break
      else
      Begin  
        b[k] := b[k]-a[k,i]*b[i];
        for j:=i+1 to n-1 Do
          a[k,j] := a[k,j] - a[k,i] * a[i,j];
      end; 
    end;
  end;
  
  //  室
  for i:=n-2 Downto 0 Do
    for j:=i+1 to n Do
      b[i] := b[i] - a[i,j] * b[j];
End;


Var
  a: TMatrix;
  b: TVector;
  n, i, j: integer;
  f: textfile;
  start_time, end_time: TDateTime;
  hours, minutes, seconds, milliseconds: word;

Begin
  WriteLn('뢠 䠩 ...');
  AssignFile(f, 'data.txt');
  Reset(f);

  Read(f, n);
  WriteLn(' : ', n);

  // 뤥塞   ᨢ
  SetLength(a, n, n);
  SetLength(b, n);
  WriteLn('㧪   䠩...');
  For i:=0 To n-1 Do
    For j:=0 To n-1 Do
      Read(f, a[i,j]);
  For i:=0 To n-1 Do
    Read(f, b[i]);

  CloseFile(f);

  WriteLn('㧪  襭. 稭 ...');

  start_time := Time;
  gauss(a, b, n);
  end_time := Time;

  // 뢠 ⢥  䠩
  AssignFile(f, 'answer.txt');
  Rewrite(f);
  WriteLn(f, '६ ࠡ ணࠬ:');
  DecodeTime(end_time - start_time, hours, minutes, seconds, milliseconds);
  WriteLn(f, hours,' ᮢ ', minutes, '  ', seconds, ',', milliseconds, ' ᥪ㭤');
  WriteLn(f, '');;
  For i:=0 To n-1 Do
    WriteLn(f, 'x[',i,'] = ', b[i]:12:8);
  CloseFile(f);

  WriteLn(' 稫...');

End.
